#!/usr/bin/perl -w
#
# $Id: delete.pl,v 1.8 2002/07/27 18:30:04 dom Exp $
# Copyright (C) 2001, 2002 Dominic Hargreaves <dom@earth.li>
# Takes a list of the full paths of mp3s on STDIN and DELETES THEM FROM THE
# DATABASE!
#
# This file is part of mediadbs.
#
# mediadbs is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# mediadbs is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with mediadbs; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use DBI();
use Getopt::Std;

require "config.pl";
use vars qw($dbhost $dbname $dbuser $dbpass);

sub usage;
my %options;

getopts("cr:s:", \%options);
$options{c} or usage();

# Connect to the database
my $dbh = DBI->connect("DBI:mysql:database=$dbname;host=$dbhost",
                        $dbuser, $dbpass, {'RaiseError' => 1});

# Main loop

while(<STDIN>) {
   my $filename;
   my $path;
   my $fileisnotfile;
   chomp;
   if (! -f $_) {
      if (-d $_) {
         print "Entered $_\n";
      } else {
         print "Can't find file $_\n";
      }
      $fileisnotfile = "Y";
   }
   next if ($fileisnotfile eq "Y");
   my $splitfile = $_;
   $splitfile =~ s#$options{r}/##;
   my @components = split /\//, $splitfile;
   $filename = pop @components;
   $path = join "/", @components;
   my $sth = $dbh->prepare("SELECT id, updated FROM mp3 WHERE filename=\"$filename\" AND
    path=\"$path\" AND server=\"$options{s}\"");
   $sth->execute();
   while (my $mp3ref = $sth->fetchrow_hashref()) {
      next unless $mp3ref->{'id'};
      print "Deleting $_ from database\n";
      $dbh->do("DELETE from mp3 WHERE id=\"$mp3ref->{'id'}\"");
      last;
   }
}

# Clean up

$dbh->disconnect();

sub usage {
   print "Accepts a list of files to delete from the database (not the\n";
   print "filesystem) on STDIN.\n";
   print "Syntax: $0 -c\n";
   print "Must use -c to confirm your actions, since this is a dangerous";
   print " script\n";
   exit 1;
}
